#include "ptc.h"
#include "string.h"
#include "gfx/head/buf.h"
#include "gfx/head/video.h"
#include "gfx/head/map.h"
#include "world/head/world.h"
#include "gfx/head/sprite.h"
#include "world/head/effect.h"
#include "world/head/weapon.h"
#include "world/head/item.h"
#include "world/head/entity.h"
#include "gfx/head/police.h"


Police *police;
	

Police::Police(char filename[], int y)
{
	bmp = new Sprite(0, y, filename);
	polh = y;
}


Police::~Police()
{
	bmp->~Sprite();
	polh = 0;
}



Police::BlitTxt(char texte[], int x, int y, int w)
{
	int xsprt;
	int i;

	xsprt = x;
	bmp->width = w;	
	bmp->framey = 1;

	for(i=0 ; i<int(strlen(texte)) ; i++)
	{
		if(texte[i]!=' ')
		{
			bmp->xs = x + (w*i);
			bmp->ys = y;
			bmp->framex = texte[i] - 'a';
			bmp->Show();
		}
	}
}


Police::BlitInt(int val, int x, int y, int w)
{
	int v;	
	
	bmp->width  = w;
	bmp->framey = 0;

	if(val>=0)
	{
		v = val;
	}
	else
	{
		bmp->xs = x;
		bmp->ys = y;
		bmp->framex = 10;
		bmp->Show();
		v = -val;
	}

	bmp->xs = x + w;
	bmp->ys = y;
	bmp->framex = int(v/100);
	bmp->Show();
	bmp->xs = x + w * 2;
	bmp->ys = y;
	bmp->framex = int((v - int(v/100)*100)/10);
	bmp->Show();
	bmp->xs = x + w * 3;
	bmp->ys = y;
	bmp->framex = v - int(v/100)*100 - int((v - int(v/100)*100)/10)*10;
	bmp->Show();
}



void Draw_Board(Entity *Ent, Police *pol)
{
	pol->BlitInt(Ent->pack->health, 230, 195, 15);
	if(Ent->pack->weap_sel>-1)
	{
		pol->BlitInt(Ent->pack->_ammo[Weaps->weaps[Ent->pack->weap_sel].ammotype], 5, 195, 15);
		pol->BlitTxt(Weaps->ammos[Weaps->weaps[Ent->pack->weap_sel].ammotype].aname, 5, 170, 10);
		pol->BlitTxt(Weaps->weaps[Ent->pack->weap_sel].wname, 90, 195, 10);
	}
	pol->BlitTxt("frags", 65, 30, 10);
	pol->BlitInt(Ent->pack->frags, 5, 30, 15);
}




