#include "ptc.h"
#include "stdio.h"
#include "fstream.h"
#include "gfx/head/video.h"
#include "gfx/head/buf.h"
#include "gfx/head/map.h"
#include "gfx/head/sprite.h"
#include "world/head/effect.h"
#include "world/head/blood.h"
#include "world/head/weapon.h"
#include "world/head/entity.h"
#include "world/head/player.h"
#include "world/head/item.h"
#include "world/head/world.h"

Map *map;
Buf *screen;

int num_ent;
float world_speed;
float world_gravity;

int endmatch;
int xw;

int EMUSIC;

int SKILL;
double FPS;
	
void Init_World(char filename[])
{
	int nbobj;
	int xo, yo, to, op;
	FILE *fichier;
	char chaine[200];
	
	fichier = fopen(filename,"rt");

	fscanf(fichier,"%s",&chaine);
	map = new Map(chaine);
	Items = new items("base/effects/items.bmp");
		
	fscanf(fichier,"%i",&nbobj);

	for(int i=0 ; i<nbobj ; i++)
	{
		fscanf(fichier,"%s",&chaine);
		fscanf(fichier,"%i",&to);
		fscanf(fichier,"%i",&xo);
		fscanf(fichier,"%i",&yo);
		fscanf(fichier,"%i",&op);
		Items->Add(xo*3, yo*3, to, op);
	}

	fclose(fichier);

	
	num_ent = 0;
	
	Weaps = new Weapons("base/effects/weaps.bmp");
	Effects = new Effect("base/effects/effect.bmp");
	blood = new Blood();

	world_speed = 3.;
	world_gravity = 2.;
	endmatch = 0;
	
	EBbump=0;
	if(SKILL==BRING_IT_ON) FPS=70.;
	if(SKILL==HURT_ME_PLENTY) FPS=80.;
	if(SKILL==HARDCORE) FPS=90.;
	if(SKILL==NIGHTMARE) { FPS=100.; EBbump=1; }
}




void Exit_World()
{
	map->~Map();
	Items->~items();
	Weaps->~Weapons();
	Effects->~Effect();
	blood->~Blood();
}

